import java.awt.*;
import java.util.*;


public class CompFrame extends Frame {
   UserArea ua = new UserArea();
   DiskArea da = new DiskArea();
   ProcessArea pa = new ProcessArea();
   DiskMemPanel dmp = new DiskMemPanel();
   TabPanel tabPanel1;
   TabPanel tabPanel2;
   Canvas canvas1;
   Canvas canvas2;
   TabPanel tabPanel3;
   Canvas canvas3;
   Canvas canvas4;
   GraphPanel gpanel ;
   DataInfo dinfo;
   Info info ;
   boolean state = false;
  CompThread compThread;

   
   public CompFrame() 
     {
	
	gpanel = new GraphPanel();
	setLayout(new BorderLayout(0,0));
	addNotify();
	resize(insets().left + insets().right + 600,insets().top + insets().bottom + 400);
	tabPanel2 = new TabPanel();
	tabPanel2.setLayout( null );
	tabPanel2.reshape(12,33,406,226);
	add("Center",tabPanel2);

	java.lang.String[] tempString = new java.lang.String[4];
	tempString[0] = new java.lang.String("CPU");
	tempString[1] = new java.lang.String("Disk/Memory");
	tempString[2] = new java.lang.String("Users");
	tempString[3] = new java.lang.String("Processes");
	//	tempString[4] = new java.lang.String("Network");
	tabPanel2.setPanelLabels(tempString);
	//	gpanel.add(new GraphCanvas("TEST"));
	tabPanel2.add(gpanel);
	da.add("rootfs\t\t/\text2\trw\t427409\t502\n/dev/hda1\t/dosc\tvfat\trw\t411008\t19672\n/dev/hda7\t/dose\tvfat\trw\t177184\t6788\n/dev/hda5\t/dosd\tvfat\trw\t411008\t72624\n/dev/hda4\t/extdsk\text2\trw\t115163\t16684");
	da.show_text();
	tabPanel2.add(da);
	ua.add("root\troot\t\ttty1\t\tThu Apr 10 06:27:39 1997\nroot\troot\t\tttyp0\t:0.0\tThu Apr 10 07:04:19 1997\nroot\troot\t\tttyp1\t:0.0\tThu Apr 10 06:28:58 1997\nroot\troot\t\tttyp2\t:0.0\tThu Apr 10 06:58:30 1997\nmilan\tMilan Gabor\tttyp4\tlocalhost\tThu Apr 10 09:31:26 1997\n");
	ua.show_text();

        tabPanel2.add(ua);
	
	
	
     		//{{INIT_CONTROLS
		setLayout(null);
		setSize(insets().left + insets().right + 430,insets().top + insets().bottom + 270);
		setTitle("Untitled");
		//}}
		//{{INIT_MENUS
		//}}
}
   
   public CompFrame(String title) 
     {
	this();
	setTitle(title);
     }
  
   public CompFrame (String name, Info inf, CompThread ct)
     {
       compThread = ct;
	setBackground(Color.lightGray);
	info = inf ;
	gpanel = new GraphPanel(info);
	setLayout(new BorderLayout(0,0));
	addNotify();
	resize(insets().left + insets().right + 600,insets().top + insets().bottom + 400);
	tabPanel2 = new TabPanel();
	tabPanel2.setLayout( null );
	tabPanel2.reshape(12,33,406,226);
	add("Center",tabPanel2);

	java.lang.String[] tempString = new java.lang.String[5];
	tempString[0] = new java.lang.String("CPU");
	tempString[1] = new java.lang.String("Disk/Memory");
	tempString[2] = new java.lang.String("Users");
	tempString[3] = new java.lang.String("Processes");
	//	tempString[4] = new java.lang.String("Network");
	
	tabPanel2.setPanelLabels(tempString);
	tabPanel2.add(gpanel);
//	da.add("rootfs\t\t/\text2\trw\t427409\t502\n/dev/hda1\t/dosc\tvfat\trw\t411008\t19672\n/dev/hda7\t/dose\tvfat\trw\t177184\t6788\n/dev/hda5\t/dosd\tvfat\trw\t411008\t72624\n/dev/hda4\t/extdsk\text2\trw\t115163\t16684");
	da.reset_text();
	da.show_text();
	tabPanel2.add(dmp);
	//ua.add("root\troot\t\ttty1\t\tThu Apr 10 06:27:39 1997\nroot\troot\t\tttyp0\t:0.0\tThu Apr 10 07:04:19 1997\nroot\troot\t\tttyp1\t:0.0\tThu Apr 10 06:28:58 1997\nroot\troot\t\tttyp2\t:0.0\tThu Apr 10 06:58:30 1997\nmilan\tMilan Gabor\tttyp4\tlocalhost\tThu Apr 10 09:31:26 1997\n");
	ua.reset_text();
	ua.show_text();
	
        tabPanel2.add(ua);
	tabPanel2.add(pa);
	//tabPanel2.add(new NetArea());
	setTitle(name);
	show();
     }
   
   
/**Initializes Vector of Canvases*/   
    public void init_vector ()
     {
	gpanel.init_vector();
     }
   
/**Adds data to Graph panel*/
   
   public void add_data (String name ,float value)
     {
	gpanel.add_data(name, value);
     }
   
   
   
/**Method, which shows Frame*/
   
   public synchronized void show() {
      move(50, 50);
      super.show();
   }
   
   
   /**Handling Events*/
   public boolean handleEvent(Event event) {
      if (event.id == Event.WINDOW_DESTROY) {
	 hide();         // hide the Frame
	 dispose();
	 compThread.windowClose();
	 compThread.close_all();
//	 System.exit(0);
	 return true;
      }
      return super.handleEvent(event);
   }


   /**Adds data to USER AREA    */
    public void add_ua ( String s)
    {
       ua.add(s);
    }
    /** Adds data to DISK AREA*/     
    public void add_da(String s)
    {
       dmp.add_da(s);
       
    }

/**Adds data to MEM PANEL*/
   public void add_mem(String s1, String s2)
     {
	dmp.add_mem(s1,s2);
     }
   
	   
	
   
   /** Adds data to PROCESS AREA*/     
    public void add_pa(String s)
    {
       pa.add(s);
    }
   
   
   /** Clear text in UserArea*/     
    public void clear_text()
    {
       ua.clear_text();
       dmp.da.clear_text();
       pa.clear_text();
    }
   /** Show text in UserArea*/     
    public void show_text()
    {
       ua.show_text();
       dmp.da.show_text();
       pa.show_text();
       dmp.redraw();
    }
      /** Show text in UserArea*/     
    public void reset_text()
    {
       ua.reset_text();
       dmp.da.reset_text();
       pa.reset_text();
    }
    /**Rearanges Graphs in GraphPanel*/
    public void rearange ()
    {
       gpanel.rearange();
    }

  
    public void fill_vect ()
    {
       gpanel.fill_vect();
    }
    

 
  public void get_a()
     {
	gpanel.get_a();
     }
  
 public void add_data_vcanvas(String s, String ss)
  {
  }
 
 public void add_data_list(String s)
  {
  }
 
 public void show_all()
  {
  }
 
 
  
    public int get_X ()
     {
	return 400;
     }
   
   public int get_Y ()
     {
	return 300;
     }

 
 public void state (boolean b)
  {
 
  }

public void problems ()
  {
 
  }

public boolean get_state()
  {
    return state;
  } 

 
 public void reset_list()
  {
   
  }
 public void redraw()
 {
    gpanel.redraw();
 }
 
 

}
