/**Class which holds information about every host.
It keeps also information about os_type, and proper
image for os.*/


import java.lang.*;
import java.awt.*;

public class CompInfo extends java.lang.Object
{
  public static final int LINUX = 1;
  public static final int SOLARIS = 2;
  public static final int HPUX = 3;
  public static final int WINDOWS = 4;
    
  String name,nick;
  int os;
  Image image;
  private int xpos = 0;
  private int ypos = 0;
  String osName;
  
  boolean state = true;
  boolean processState = true;
  boolean windowAlreadyOpen = false;

  CompInfo(String n, int t, Image im)
    {
      name = n ;
      os = t ;
      image = im;
      switch (t)
	{
	case 1: osName = "linux"; break;
	case 2: osName = "solaris"; break;
	case 3: osName = "hpux"; break;
	case 4: osName = "windows"; break;
	}
    }
    
  CompInfo(String n, int t, Image im,String ni)
    {
      name = n ;
      os = t ;
      image = im;
      nick = ni;
      switch (t)
	{
	case 1: osName = "linux"; break;
	case 2: osName = "solaris"; break;
	case 3: osName = "hpux"; break;
	case 4: osName = "windows"; break;
	}
    }
    void paint(Graphics g, Canvas c)
    {

      if(!state)
	{
	  g.setColor(Color.red);
	  g.fillRect(xpos-5,ypos-2,80,24);
	}
      else if(!processState)
	{
	  g.setColor(Color.yellow);
	  g.fillRect(xpos-5,ypos-2,80,24);
	}
      else
	{
	  g.setColor(Color.green);
	  g.fillRect(xpos-5,ypos-2,80,24);
	}

        if (image != null) 
	  g.drawImage(image,xpos,ypos,c);
	else
	  Messages.addText(name+"Picture has null reference");
	g.setFont(new Font ("Helvetica", Font.PLAIN, 10));
	g.setColor(Color.black);
	g.drawString(nick,xpos,ypos+32);
	if (!state)
	  {
	    g.setFont(new Font ("Serif", Font.BOLD, 50));
	    g.setColor(Color.red);
	    // g.drawString("?",xpos+30,ypos+30);

	  }

	if (!processState)
	  {
	    g.setFont(new Font ("Serif", Font.BOLD, 50));
	    g.setColor(Color.yellow);
	    //g.drawString("!",xpos+10,ypos+30);
	  }

	  
    }
    
    void setX(int a)
    {
        xpos = a;
    }
    
    void setY(int a)
    {
        ypos = a;
    }
    
    int getX()
    {
        return xpos;
    }
    
    int getY()
    {
        return ypos;
    }
 
  boolean getState()
    {
      return state;
    }

  void setState(boolean b)
    {
      state = b;
    
    }
    
    public void inBounds(int x, int y)
    {
        if ( (x > xpos) && (x < xpos +80) 
        && (y > ypos) && ( y < ypos + 30))
        {
	  //System.out.println("new host window "+ name);        
	  if (state)
	    {
	      new CompThread(this,name);
	    }
	}
    }

  public String getHost()
    {
      return name;
    }

  public String getOS()
    {
      return osName;
    }
  
  public void setWindowClose()
    {
      windowAlreadyOpen = false;
    }

  public void setProcessState(boolean b)
    {
      processState = b;
    }

  public void setNick(String n)
    {
      nick = n;
    }

  public String getNick()
    {
      return nick;
    }
      
}







