import java.awt.*;
import java.util.*;

class GraphCanvas extends Canvas
{
   static final int MAX_DATA = 100;
   Dimension d;
   Vector data;
   Integer integer;
   private double ratio =1.0;
   int counter=0;
   String name ;
   int actual ;
   private boolean state = true;
   private int max_value = 100;             //
   boolean debug = false;
   
  public  GraphCanvas (String name)
  {
    this.name = name;
    setBackground( Color.white);
    repaint();
    data = new Vector(100);
    for ( int i = 0; i< 100; i++) data.addElement( new Integer(0));

    
}
  
  public void paint (Graphics g)
  {
    FontMetrics fm = g.getFontMetrics();
    d=this.size();
    int value = 0;
    int temp;

  
     
    g.setColor(Color.white);
    g.fillRect(0,0,d.width,d.height);
    g.setColor(Color.black);
    g.drawRect(0,0,d.width,d.height);
    
    if (state)
      {
	g.setColor(Color.black);
	for (int i = 0; i <= data.size()-1; i++)
	  {
	    integer = (Integer)data.elementAt(i);
	    value = integer.intValue();
	    g.drawLine( i,d.height,i,(int) ((d.height- (value/2)*ratio)));
	  }
	 g.setColor(Color.red);
	 g.drawLine(0,15,100,15);
	 //g.drawString("MAX: " + max_value, 5,25);
	 //g.drawString("NEW: " + actual, 5,35);
	 //g.drawString("RATIO: " + ratio, 5,45);
	 g.setColor(Color.blue);
	 temp = fm.stringWidth(name);
	 g.drawString(name,(d.width-temp)/2,12);
	 if (debug)
	 {
	    System.out.println("Vrednost : "+value);
	    System.out.println("Risem do : "+(int) (d.height-( (value/2)*ratio)));
	 }
      }
    else
      {
	g.setColor(Color.blue);
	temp = fm.stringWidth(name);
	g.drawString(name,(d.width-temp)/2,20);
	temp = fm.stringWidth("Not Available");
	g.setColor(Color.red);
	g.drawString("Not Available",(d.width-temp)/2,40);
      }
  }

public void set_state (boolean b)
  {
    state = b;
    repaint();
  }
public void state (boolean b)
  {
    state = b;
    repaint();
  }
public boolean get_state()
  {
    return state;
  } 

 public void update (Graphics g)
     {
	paint (g);
     }

   public Dimension minimumSize()
  {
    return new Dimension (100 ,65 );
  }
 
public Dimension preferredSize ()
  {
    return minimumSize ();
  }


public String get_name()
  {
    return name;
  }

   
public void add_data ( int dat)
  {

     
     data.addElement( new Integer( dat));
     actual = dat;
     
     
     
       if (data.size() > MAX_DATA)
       {
	  data.removeElementAt(0);
       }
     
     if ( dat > max_value) 
       {

	  max_value = dat;
	  recalculate();
       }
     

  }

   public void recalculate ()
     {
	int new_value=0;
	double mid=0;
	int value =0;
	double tmp_max=0.0;
	

	for (int i = 0; i <= data.size()-1; i++)
	  {
	     integer = (Integer)data.elementAt(i);
	     value = integer.intValue();
	     if (value > tmp_max)
	       tmp_max = (double) value;
	  }
	ratio  = 100.0/tmp_max;  

     
	for (int i = 0; i <= data.size()-1; i++)
	  {
	     integer = (Integer)data.elementAt(i);
	     value = integer.intValue();
	     mid =  value*ratio;	
	     new_value = (int) mid;
	     data.setElementAt( new Integer( new_value), i);	     
	  }
	repaint();
     }
   
public void check_data()
  {
    int sum=0;
    int value=0;
    int new_value=0;
    double mid=0.0;
    
    for (int i = 0; i <= data.size()-1; i++)
      {
	integer = (Integer)data.elementAt(i);
	value = integer.intValue();
	sum =+ value;
      }
    
    sum = (int) sum/100;
//    System.out.println("SUM: "+sum);
    
    ratio = 50/(sum+1);
   // System.out.println("Ratio: "+sum);
    for (int i = 0; i <= data.size()-1; i++)
      {
	integer = (Integer)data.elementAt(i);
	value = integer.intValue();
       	mid =  value*ratio;
	new_value = (int) mid;
	data.setElementAt( new Integer( new_value), i);
      }
  }
     

public void redraw()
  {
    repaint();
  }
    


}
