import java.awt.*;

public class PrefDialog extends Dialog
{
  MTool parent;

	public PrefDialog(MTool parent, boolean modal)
	{
		super((Frame) parent, modal);
		this.parent = parent;

		//{{INIT_CONTROLS
		setLayout(null);
		setSize(insets().left + insets().right + 302,insets().top + insets().bottom + 232);
		setBackground(new Color(8361647));
		label1 = new java.awt.Label("Server",Label.RIGHT);
		label1.setBounds(insets().left + 36,insets().top + 36,66,24);
		add(label1);
		label2 = new java.awt.Label("Port",Label.RIGHT);
		label2.setBounds(insets().left + 36,insets().top + 78,66,24);
		add(label2);
		textField1 = new java.awt.TextField();
		textField1.setBounds(insets().left + 120,insets().top + 36,138,25);
		textField1.setBackground(new Color(16777215));
		textField1.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(textField1);
		textField2 = new java.awt.TextField();
		textField2.setBounds(insets().left + 120,insets().top + 72,48,25);
		textField2.setBackground(new Color(16777215));
		textField2.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(textField2);
		label3 = new java.awt.Label("Refresh Time",Label.RIGHT);
		label3.setBounds(insets().left + 12,insets().top + 114,90,24);
		add(label3);
		textField3 = new java.awt.TextField();
		textField3.setBounds(insets().left + 120,insets().top + 108,48,25);
		textField3.setBackground(new Color(16777215));
		textField3.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(textField3);
		button1 = new java.awt.Button();
		button1.setActionCommand("button");
		button1.setLabel("OK");
		button1.setBounds(insets().left + 54,insets().top + 174,60,24);
		button1.setBackground(new Color(12632256));
		add(button1);
		button2 = new java.awt.Button();
		button2.setActionCommand("button");
		button2.setLabel("Cancel");
		button2.setBounds(insets().left + 168,insets().top + 174,60,24);
		button2.setBackground(new Color(12632256));
		add(button2);
		setTitle("Preferences");
		setResizable(false);
		//}}



		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
		//}}
		
		textField1.setText(Preferences.getServerName());
		textField2.setText(""+Preferences.getServerPort());
		textField3.setText(""+Preferences.getRefreshTime());
		

	}
	
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;


	public PrefDialog(MTool parent, String title, boolean modal)
	{
	  this( parent, modal);
	  setTitle(title);
	}

	public synchronized void show()
	{
		Rectangle bounds = getParent().bounds();
		Rectangle abounds = bounds();

		move(bounds.x + (bounds.width - abounds.width)/ 2,
			 bounds.y + (bounds.height - abounds.height)/2);

		super.show();
	}

	//{{DECLARE_CONTROLS
	java.awt.Label label1;
	java.awt.Label label2;
	java.awt.TextField textField1;
	java.awt.TextField textField2;
	java.awt.Label label3;
	java.awt.TextField textField3;
	java.awt.Button button1;
	java.awt.Button button2;
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == PrefDialog.this)
				Dialog1_WindowClosing(event);
		}
	}
	
	void Dialog1_WindowClosing(java.awt.event.WindowEvent event)
	{
		hide();
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_Action(event);
			else if (object == button2)
				button2_Action(event);
		}
	}

	void button1_Action(java.awt.event.ActionEvent event)
	{
	  String status;
		// to do: code goes here.
			 
		//{{CONNECTION
		// Select all of the text
	  //textField1.selectAll();
		//}}
	  status = (new CheckComputer(textField1.getText(),new Integer(textField2.getText()).intValue())).checkConnection();
	  if(status == "")
	    {
	      Preferences.setServerName(textField1.getText());
	      Preferences.setServerPort(new Integer(textField2.getText()).intValue());
	      Preferences.setRefreshTime(new Integer(textField3.getText()).intValue());
	      parent.get_all_hosts();
	      dispose();
	    }
	  else
	    {
	      Messages.addText(status);
	    }
	  
	}

	void button2_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Select all of the text
	  //textField1.selectAll();
		//}}
	  dispose();
	}
}
