import java.awt.*;

public class RemoveHostDialog extends Dialog
{
	public RemoveHostDialog(Frame parent, boolean modal)
	{
		super(parent, modal);


		//{{INIT_CONTROLS
		setLayout(null);
		setSize(insets().left + insets().right + 246,insets().top + insets().bottom + 214);
		setBackground(new Color(8361647));
		button1 = new java.awt.Button();
		button1.setActionCommand("button");
		button1.setLabel("Remove");
		button1.setBounds(insets().left + 40,insets().top + 170,54,27);
		button1.setBackground(new Color(12632256));
		add(button1);
		button2 = new java.awt.Button();
		button2.setActionCommand("button");
		button2.setLabel("Cancel");
		button2.setBounds(insets().left + 145,insets().top + 170,54,27);
		button2.setBackground(new Color(12632256));
		add(button2);
		label1 = new java.awt.Label("Select computer to remove",Label.CENTER);
		label1.setBounds(insets().left + 23,insets().top + 25,199,25);
		add(label1);
		list1 = new java.awt.List(0,false);
		CompInfo tmp ;
		for ( int i = 0; i  < CompVector.size(); i++)
		  {
		    tmp = (CompInfo) CompVector.elementAt(i);
		    list1.addItem(tmp.getHost());
		  }
		add(list1);
		list1.setBounds(insets().left + 35,insets().top + 70,160,70);
		setTitle("Remove Host");
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		button2.addActionListener(lSymAction);
		button1.addActionListener(lSymAction);
		//}}
	}
	
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;


	public RemoveHostDialog(Frame parent, String title, boolean modal)
	{
		this(parent, modal);
		setTitle(title);
	}

	public synchronized void show()
	{
		Rectangle bounds = getParent().bounds();
		Rectangle abounds = bounds();

		move(bounds.x + (bounds.width - abounds.width)/ 2,
			 bounds.y + (bounds.height - abounds.height)/2);

		super.show();
	}

	//{{DECLARE_CONTROLS
	java.awt.Button button1;
	java.awt.Button button2;
	java.awt.Label label1;
	java.awt.List list1;
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == RemoveHostDialog.this)
				Dialog1_WindowClosing(event);
		}
	}
	
	void Dialog1_WindowClosing(java.awt.event.WindowEvent event)
	{
		hide();
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button2)
				button2_Action(event);
			else if (object == button1)
				button1_Action(event);
		}
	}

	void button2_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
	 
	  this.dispose();
	  //{{CONNECTION
		// Repaint the Dialog
	  //repaint();
		//}}
	}

	void button1_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
	  //  System.out.println("SELECTED = "+list1.getSelectedItem());
	  CompInfo ci;
	  for ( int i = 0; i < CompVector.size();i++)
	    {
	      ci = (CompInfo) CompVector.elementAt(i);
	      if (ci.getHost().equalsIgnoreCase(list1.getSelectedItem()))
		new RemoveHost(list1.getSelectedItem(),ci.getOS(),ci.getNick());
	    }
	  dispose();
		//{{CONNECTION
		// Repaint the Dialog
	
		//}}
	}
}
