import java.io.*;
import java.net.*;

public abstract class SocketClient 
{
  Socket socket;
  DataInputStream in;
  PrintStream out;
  boolean connected = false ;
  
  public SocketClient( String host, int port) throws IOException
  {
    socket = new Socket(host, port);
    in = new DataInputStream(socket.getInputStream());
    out = new PrintStream (socket.getOutputStream());
    connected = true ;
}

  public void write(String data)
  {
    out.println(data);
  }

  public String read() throws IOException
  {
    return in.readLine();
  }
  
  public void disconnect ()
     {
	if ( connected )
	  {
	     try
	       {
		  in.close();
		  out.close();
	       } catch (IOException e) { }
	     if ( socket != null )
	       {
		  try {socket.close();
		  }
		  catch (Exception e) { }
	       }
	  }
	in = null;
	out = null;
	socket = null;
	connected = false;
     }
  
 public boolean isConnected () { return connected;}


  public abstract String get_line();
  public abstract boolean protocol();
  

}
