#include <sys/types.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <nlist.h>
#include <mntent.h>
#include <sys/dk.h>
#include <sys/pstat.h>
#include <string.h>
#include <sys/sysmacros.h>
#include <sys/vfs.h>


/* 
 * for disk information
 */
# define MAX_DISKS 16
#define DEVICE_SIZE 40
#define PATH_SIZE 80

struct dddk {
	char dev[DEVICE_SIZE];
	char path[PATH_SIZE];
	int maj;
	int min;
	int  ok;
};

/*
 * disk
 */
struct pst_diskinfo pstk1[MAX_DISKS];
struct pst_diskinfo pstk2[MAX_DISKS];
long disk_xfers[MAX_DISKS];
long disk_wds[MAX_DISKS];
struct dddk mine[MAX_DISKS];

int disk_devices=0;
int delay = 4;



/**************************************************************************/
/*
 * try to get disk names
 */
void
pre_disk_info ()
{
   FILE *fp;
   struct stat st;
   struct mntent *mp;
   int count = 0;

   fp = setmntent(MNT_MNTTAB, "r");

   while ((mp = getmntent(fp)) != NULL) {
      s_strcpy (mine[count].dev, mp->mnt_fsname, DEVICE_SIZE);
      s_strcpy (mine[count].path, mp->mnt_dir, PATH_SIZE);
      
      if ( !strcmp (mp->mnt_type, MNTTYPE_HFS) ||
	  !strcmp (mp->mnt_type, MNTTYPE_CDFS) ||
	  !strcmp (mp->mnt_type, MNTTYPE_VXFS) ||
	  !strcmp (mp->mnt_type, MNTTYPE_SWAP)) {
	 stat (mine[count].dev, &st);
	 mine[count].min = minor(st.st_rdev);
	 mine[count].maj = major(st.st_rdev);
	 mine[count].ok = 1;
	 //printf("\n%s %s\n",       mine[count].dev, mine[count].path );
	 
	   count++;
	} else {
		continue;
	}

   }

   mine[count].ok = 0;

	disk_devices = count - 1;

   fclose(fp);
}
/*************************** DISK NAMES **************************************/


print_disk()
{
   
   int i;
   struct statfs fsbuf;
   long blocks_free, nodes_free;
   char buf[90];
   char nodes_str[12];
   
   
   for (i=0; i <= disk_devices ;  i++) 
     {
	if (!mine[i].ok)
	  break;
        statfs(mine[i].path,&fsbuf); /* to get blocks */
//	blocks_free = fsbuf.f_bfree;
//	nodes_free = fsbuf.f_files;

	
	blocks_free = fsbuf.f_bavail;
	nodes_free = fsbuf.f_ffree;
	
	sprintf (buf, "|disk|%s|%s|vfs|rw|%.2fM|%.2fM| ",
		 mine[i].dev, mine[i].path,
		 (float)(fsbuf.f_blocks)/(float)fsbuf.f_bsize,
		  (float)(blocks_free)/(float)fsbuf.f_bsize);
	printf("%s\n",buf);
     }
   
	
	
   
}


int
s_strcpy (dest, src, len)
char *dest, *src;
int len;
{
	if (strlen (src) >= len) {
		strncpy (dest, src, len-1);
		dest[len-1]='\0';
	}
	else
		strcpy (dest, src);
}





/*
void main(int argc, char **argv)
{
  pre_disk_info();
   //get_disk();
   //sleep(4);
   //get_disk();
   print_disk();
   exit(0);
}*/


