#include <sys/pstat.h>
#include <sys/types.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <nlist.h>
#include <mntent.h>
#include <sys/dk.h>
#include <sys/utsname.h>
#include <ustat.h>
#include <sys/vfs.h>
#include <string.h>
#include <ctype.h>
#include <sys/netio.h> /* for lan card status */
#include <sys/types.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <nlist.h>
#include <mntent.h>
#include <sys/dk.h>
#include <sys/fcntl.h>
#include <sys/file.h>
#include <sys/time.h>
#include <utmp.h>
#include <pwd.h>


extern pre_disk_info();
extern print_disk();



#define MAX_DISKS 16
#define DEVICE_SIZE 40
#define PATH_SIZE 80
#define KMEM    "/dev/kmem"
#define MEM     "/dev/mem"
#define O_RDONLY      0000000
#if HPUX>=1000
# define VMUNIX "/stand/vmunix"
#else
# define VMUNIX "/hp-ux"
#endif



#ifdef __hp9000s300
static struct nlist nlst[] = {
#define N_DFILE_DATA 0
   { "_dfile_data" },
#define N_BUFP 1
   { "_bufpages" },
#define N_MAXUPRC 2
   { "_maxuprc" },
#define N_PROC 3
   { "_proc" },
   { "" }
};
#else /* 700 */
static struct nlist nlst[] = {
#define N_DFILE_DATA 0
   { "dfile_data" },
#define N_BUFP 1
   { "bufpages" },
#define N_MAXUPRC 2
   { "maxuprc" },
#define N_PROC 3
   { "proc" },
   { "" }
};
#endif
#define KNAME_LEN 80
char kernel_name[KNAME_LEN];
/*
static struct nlist nlst[] = {
    { "_avenrun" },             
{ "_cexp" },                
    { "_nproc" },              
    { "_proc" },                
    { "_total" },               
    { "_cp_time" },             
    { "_mpid" },                
#ifdef X_HZ
    { "_hz" },                 
#endif
    { 0 }
};*/







struct dddk {
        char dev[DEVICE_SIZE];
        char path[PATH_SIZE];
        int maj;
        int min;
        int  ok;
};

/*Needed for load*/
struct pst_dynamic pstd;
struct pst_static pstatic;
long former_cpu [PST_MAX_CPUSTATES];
double current_total = 0.0;
double former_total = 0.0;

/*Needed for DISK INFO */
struct pst_diskinfo pstk1[MAX_DISKS];
struct pst_diskinfo pstk2[MAX_DISKS];
long disk_xfers[MAX_DISKS];
long disk_wds[MAX_DISKS];
struct dddk mine[MAX_DISKS];
extern disk_devices;
long page_size;
int kmem;

double megs (pg)
long pg;
{

   return ((double)pg * page_size / (1024.0 * 1024.0));
}


int
getkval (offset, ptr, size)
unsigned long offset;
char *ptr;
int size;
{
   if (!kmem)
     {
	
	if ((kmem = open(KMEM, O_RDONLY)) == -1) {
	   perror(KMEM);
	   return(-1);
	}
     }
   
	   
   if (lseek(kmem, (long)offset, L_SET) == -1) {
                return (-1);
        }

        if (read(kmem, ptr, size) == -1) {
                return (-1);
        }

        return (0);
}



int load( first)
int first;
{
   int ret;
   long all;
   int i;
   
   for (i = 0 ; i <= CP_SSYS; i++) 
     {
	former_cpu[i] = pstd.psd_cpu_time[i];
     }
   former_total = current_total;
   
   ret = pstat_getdynamic (&pstd, sizeof (struct pst_dynamic), 0, 0);
   
   if (ret == -1) 
     {
	fprintf (stderr, "Bad dynamic\n");
	current_total = former_total + 1;
	current_total = former_total + 1;
	return (-1);
     } 
   all = 0;
   for (i=0; i <= CP_SSYS; i++)
     all += pstd.psd_cpu_time[i];
   current_total = all;
   if (first)
     {
	printf ("|GRAPH|LOAD_avg1|%4.2f|", pstd.psd_avg_1_min);
	printf ("GRAPH|LOAD_avg2|%4.2f|", pstd.psd_avg_5_min);
	printf ("GRAPH|LOAD_avg3|%4.2f|", pstd.psd_avg_15_min);
	/*   printf ("total virtual mem : %d\n", pstd.psd_vm);
	 printf ("active virtual mem : %d\n", pstd.psd_avm);
	 printf ("load1 : %f\n", pstd.psd_avg_1_min);
	 */ 
     }
/*
   printf ("%f \n",megs( pstd.psd_rm));
   printf ("%f \n",megs( pstd.psd_arm));
   printf ("%f \n",megs( pstd.psd_vm));
   printf ("%f \n",megs( pstd.psd_avm));
  */ 
   return(0);
}


int disk()
{
   FILE *fp;
   struct stat st;
   struct mntent *mp;
   int count = 0;
   
   fp = setmntent(MNT_MNTTAB, "r");

   while ((mp = getmntent(fp)) != NULL) {
      strncpy (mine[count].dev, mp->mnt_fsname, DEVICE_SIZE);
      strncpy (mine[count].path, mp->mnt_dir, PATH_SIZE);
      
      if ( !strcmp (mp->mnt_type, MNTTYPE_HFS) ||
	  !strcmp (mp->mnt_type, MNTTYPE_CDFS) ||
#if HPUX >= 1000
	  !strcmp (mp->mnt_type, MNTTYPE_VXFS) ||
#endif	 
	  !strcmp (mp->mnt_type, MNTTYPE_SWAP)) {
	 stat (mine[count].dev, &st);
	/* mine[count].min = minor(st.st_rdev);
	 mine[count].maj = major(st.st_rdev);*/
	 mine[count].ok = 1;
	 count++;
      } 
      else 
	{
	   continue;
	}
      
   }
   
   mine[count].ok = 0;
   disk_devices = count - 1;
   fclose(fp);

   printf ("DISK : %s  mounted as: \t %s\n", mine[0].dev, mine[0].path);
 
   
   return (1);
}

   
   

void
do_cpu()
{
   char buf[81];
   char buf1[81];
   double tot;
	

	tot = current_total;
	tot /= 100.0; /* percent */
	/*
	 * I need 4 '%'s because I use printf twice
	 */
	/*
	 * on 800s, CP_WAIT is defined (possibly CP_BLOCK CP_SWAIT too)
	 * (spinlock block) and (kernel semaphore block).
	 * not sure if CP_INTR and SSYS are used ?
	 */
/*	sprintf (buf, "%4.1f%%%% %4.1f%%%% %4.1f%%%% %4.1f%%%%",
		(double)(pstd.psd_cpu_time[CP_USER] +
					pstd.psd_cpu_time[CP_NICE]) / tot,

		(double)(pstd.psd_cpu_time[CP_SYS])/tot,

		(double)(pstd.psd_cpu_time[CP_IDLE])/tot,


		(double)(pstd.psd_cpu_time[CP_INTR] +
					pstd.psd_cpu_time[CP_SSYS])/tot);
   
   printf("%s \n", buf);*/
   
   tot = (current_total - former_total) / 100.0;
   
   
   sprintf (buf1, "|GRAPH|CPU_user|%4.1f|GRAPH|CPU_system|%4.1f|GRAPH|CPU_idle|%4.1f|",
	    (double)(pstd.psd_cpu_time[CP_USER] + pstd.psd_cpu_time[CP_NICE] -
					former_cpu[CP_USER] - former_cpu[CP_NICE]) / tot,
	    
		(double)(pstd.psd_cpu_time[CP_SYS] - former_cpu[CP_SYS])/tot,
	    
	    (double)(pstd.psd_cpu_time[CP_IDLE] - former_cpu[CP_IDLE])/tot);
   printf("%s \n", buf1);
   
}


void users()
{
    char name[64];
   char *name1;
   struct passwd *pwd;
   struct utmp *utmpx;
   struct hostent *hp;
   char *time;
   
   while ((utmpx = getutent()) != NULL) 
     {
      /*
       * Skip records that aren't logins.
       */
      if (utmpx->ut_type != USER_PROCESS)
	continue;
      
       if ((pwd = getpwnam(utmpx->ut_user)) != NULL)
            strcpy(name, pwd->pw_gecos);
        else
            sprintf(name, "#%d", pwd->pw_uid);

	time =  ctime(&utmpx->ut_time);
	time [strlen(time) -1 ] = '\0';

      
      printf("|user|%s|%s|%s|%s|%s", utmpx->ut_user, name,
	     utmpx->ut_line,  utmpx->ut_host,time);
   }
}











main ()
{
   int ret ;
   caddr_t bufpages_addr; /* address is mem where bufpages lives */
   unsigned bufpages=0; /*  bufpages */



   


   
   ret = pstat_getstatic(&pstatic, sizeof(struct pst_static), 0, 0);
   if (ret == -1)
     {
	printf("Error attemping to get static data");
     }

    strcpy (kernel_name, VMUNIX);
   
   bufpages_addr = (caddr_t)nlst[N_BUFP].n_value;
   (void) getkval (bufpages_addr, &bufpages, sizeof(bufpages));
   
   
   page_size = pstatic.page_size;

   pre_disk_info();
   load(0);
   sleep(1);
   load(1);
   do_cpu();
   print_disk();
   users();

}

