#include <sys/types.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <nlist.h>
#include <mntent.h>
#include <sys/dk.h>
#include <sys/pstat.h>


/* 
 * for disk information
 */
# define MAX_DISKS 16
#define DEVICE_SIZE 40
#define PATH_SIZE 80

struct dddk {
	char dev[DEVICE_SIZE];
	char path[PATH_SIZE];
	int maj;
	int min;
	int  ok;
};


int disk_devices=0;



/**************************************************************************/
/*
 * try to get disk names
 */
void
pre_disk_info ()
{
   FILE *fp;
   struct stat st;
   struct mntent *mp;
   int count = 0;

   fp = setmntent(MNT_MNTTAB, "r");

   while ((mp = getmntent(fp)) != NULL) {
      s_strcpy (mine[count].dev, mp->mnt_fsname, DEVICE_SIZE);
      s_strcpy (mine[count].path, mp->mnt_dir, PATH_SIZE);

	if ( !strcmp (mp->mnt_type, MNTTYPE_HFS) ||
		!strcmp (mp->mnt_type, MNTTYPE_CDFS) ||
#if HPUX >= 1000
		!strcmp (mp->mnt_type, MNTTYPE_VXFS) ||
#endif
		!strcmp (mp->mnt_type, MNTTYPE_SWAP)) {
		stat (mine[count].dev, &st);
		mine[count].min = minor(st.st_rdev);
		mine[count].maj = major(st.st_rdev);
		mine[count].ok = 1;
        	count++;
	} else {
		continue;
	}

   }

   mine[count].ok = 0;

	disk_devices = count - 1;

   fclose(fp);
}
/*************************** DISK NAMES **************************************/

/*
 * get disk info
 */
void
get_disk()
{
   int i;
   static int first_time = 1;

   /*
    * third arg seems to be the number of disks...
    */

   /*
    * note DK_NDRIVE drives possible
    */

   (void)memcpy (&pstk1[0], &pstk2[0], MAX_DISKS * sizeof (struct pst_diskinfo))
;

   /*
    * 1 now has old, 2 ready for new
    */

   (void)pstat_getdisk (&pstk2[0], sizeof (struct pst_diskinfo), MAX_DISKS, 0);

   if (first_time) {
      first_time = 0;
      return;
   }
   for (i=0; i<=disk_devices; ++i) {
      disk_xfers [i] = pstk2[i].psd_dkxfer - pstk1[i].psd_dkxfer;
      disk_wds [i] = pstk2[i].psd_dktime - pstk1[i].psd_dktime;
   }
}


/**************************************************************************/



