#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <fcntl.h>
#include <limits.h>
#include <rpc/rpc.h>
#include <sys/socket.h>
//#include <nlist.h>
#include <syslog.h>
#include <sys/errno.h>
#include <sys/param.h>
#include <net/if.h>
#include <utmp.h>
#include <rpcsvc/rstat.h>
#include <sys/vfs.h>
#include <sys/types.h>
#include <sys/time.h>
#include <utmp.h>
#include <pwd.h>
#include <dirent.h>
#include <sys/stat.h>
#include <sys/time.h>

#define LOADAVG "/proc/loadavg"
#define STAT "/proc/stat"
#define MEMINFO "/proc/meminfo"

#define bytetok(x)    (((x) + 512) >> 10)
#define pagetok(x)      ((x) << (PAGE_SHIFT - 10))
#define HASH(x)         (((x) * 1686629713U) % HASH_SIZE)
#define FSCALE (1<<FSHIFT)

static long cp_time[4];
static long cp_old[4];
static long cp_diff[4];
static long cpu_states[4];
long in_pkt, out_pkt, col_pkt;
int ii ;
char *CONF_FILE = "/etc/mtoold.conf";
int number_monitored = 0;

static struct timeval lasttime;

struct statmem
{
      u_int total;
      u_int used;
      u_int free;
      u_int swap;
      u_int swap_used;
      u_int swap_free;
};

 struct process_tmp
   {
         char 		comm[ 32];	/* Never seems to be > 16, but not I'm not sure.. */
	 char 		state;
	 unsigned long 	utime;
	 unsigned long 	stime;
	 long int 	priority;
	 unsigned long 	vsize;
	 long int 	rss;
	 unsigned long	wchan;
   };

   struct process_table
   {
         char     name[32];
	 int      working ;
   };
/* We assume, there will not be more than 64 observable processes*/
   struct process_table ptable [64];
/*Here we get load for this computer.*/
get_load()
  {
     FILE *fla;
     double avrun[3];
     struct statsswtch s2;	
     
     if((fla = fopen(LOADAVG, "r")) == NULL)
       {
	  syslog(LOG_ERR, "can't open /proc/loadavg");
       }
     fscanf(fla, "%lf %lf %lf", &avrun[0], &avrun[1], &avrun[2]);
     printf("GRAPH|LOAD_avg1|%2.2f|",avrun[0]);
     printf("GRAPH|LOAD_avg2|%2.2f|",avrun[1]);
     printf("GRAPH|LOAD_avg3|%2.2f|",avrun[2]);
  } 

/*
 *  *  percentages(cnt, out, new, old, diffs) - calculate percentage change
 *  *      between array "old" and "new", putting the percentages i "out".
 *  *      "cnt" is size of each array and "diffs" is used for scratch space.
 *  *      The array "old" is updated on each call.
 *  *      The routine assumes modulo arithmetic.  This function is especially
 *  *      useful on BSD mchines for calculating cpu state percentages.
 *  */

long percentages(cnt, out, new, old, diffs)
  
int cnt;
int *out;
register long *new;
register long *old;
long *diffs;

{
   register int i;
   register long change;
   register long total_change;
   register long *dp;
   long half_total;
   /* initialization */
   total_change = 0;
   dp = diffs;
   
   /* calculate changes for each state and the overall change */
   for (i = 0; i < cnt; i++)
     {
	if ((change = *new - *old) < 0)
	  {
	     
	     /* this only happens when the counter wraps */
	     change = (int)
	       ((unsigned long)*new-(unsigned long)*old);
	  }
	
	total_change += (*dp++ = change);
	*old++ = *new++;
     }
   
   
   /* calculate percentages based on overall change, rounding up */
   half_total = total_change / 2l;
   for (i = 0; i < cnt; i++)
     {
	
	*out++ = (int)((*diffs++ * 1000 + half_total) / total_change);
     }  
   /* return the total in case the caller wants to use it */
   return(total_change);
}
/* Here we get cpu in %. We call it twice, so we can compute %*/
void get_cpu(int a)
{
   FILE *fcpu;
   int ii ;
   
   if((fcpu = fopen(STAT, "r")) == NULL)
     {
	syslog(LOG_ERR, "can't open /proc/stat");
       }
   fscanf(fcpu, "cpu %i %i %i %i", &cp_time[0], &cp_time[1], &cp_time[2],&cp_time[3]);
   percentages(4,cpu_states,cp_time, cp_old, cp_diff);
   if ( a ==1)
     {  
	printf("|GRAPH|CPU_user|%3.2f|",cpu_states[0]/10.0);
	printf("|GRAPH|CPU_nice|%3.2f|",cpu_states[1]/10.0);
	printf("|GRAPH|CPU_system|%3.2f|",cpu_states[2]/10.0);
	printf("|GRAPH|CPU_idle|%3.2f|",cpu_states[3]/10.0);
     }
   fclose(fcpu);
}

/*Here we get values for memory usage*/
void get_mem()
{
   FILE *fmem;
   struct statmem smem;
   
   if((fmem = fopen(MEMINFO, "r")) == NULL)
     {
	syslog(LOG_ERR, "can't open /proc/meminfo");
     }
   fscanf(fmem," %*s %*s %*s %*s %*s %*s\n");
   fscanf(fmem,"Mem: %u %u %u %*u %*u %*u\n",&smem.total, &smem.used, &smem.free);
   fscanf(fmem,"Swap: %u %u %u\n",&smem.swap, &smem.swap_used, &smem.swap_free);
   
   smem.total = bytetok(smem.total);
   smem.used = bytetok(smem.used);
   smem.free = bytetok(smem.free);
   smem.swap = bytetok(smem.swap);
   smem.swap_free = bytetok(smem.swap_free);
   smem.swap_used = bytetok(smem.swap_used);
   
   
   printf ("VALUE|MEM_real|%uK|",smem.total);	 
   /* printf ("MemUsed : %u\n",smem.used);*/		
   printf ("VALUE|MEM_free|%uK|",smem.free);	 
   printf ("VALUE|MEM_swap|%uK|",smem.swap);	
   /*  printf ("SwapUsed : %u\n",smem.swap_used);	 */
   printf ("VALUE|MEM_swap_free|%uK|\n",smem.swap_free);	
   fclose(fmem);
}

/*Here we get disk usage */
void disk_usage()
{
   char * buf = "";
   FILE * statfile;
   struct statfs statbuf;
   char device[ 32], mntpoint[ 64], type[32], rw[32];
   int result = 4;
   int total, total_free;
   double  percent;

   if (!(statfile = fopen( "/proc/mounts", "r")))
   {
      printf("Couldn't open /proc/mounts. ");
      return ;
   }
   while (result!= EOF)
   {
      result = fscanf( statfile, "%s %s %s %s %*d %*d \n", device, mntpoint, type, rw);
      if (result != 4)  continue;
      if (!strcmp( rw, "ro"))
	 continue;
      if (!strcmp( type, "proc"))     /* procfs gives a "rw" wrongly */
	 continue;
      if ( mntpoint[0] != '/')
	 continue;
      else
      {
	 statfs( mntpoint, &statbuf);

/*
	    printf("Mount point : %s ", mntpoint);
	    printf("Device : %s  type : %s  rw: %s \n",device,type, rw);
	    printf("Disk free : %d ..\n", (int) ( statbuf.f_bavail*statbuf.f_bsize)/1024);
	    total = (statbuf.f_blocks*statbuf.f_bsize)/1024;
	    total_free = (statbuf.f_bavail*statbuf.f_bsize)/1024 ;
	    percent = (double) total_free/total;
	    printf("total %d total_free %d percent %f \n",total, total_free,( percent*100.0));
*/
	 total = (statbuf.f_blocks*statbuf.f_bsize)/1024;
	 total_free = (statbuf.f_bavail*statbuf.f_bsize)/1024 ;
	 printf("disk|%s|%s|%s|%s|%d|%d|",device,mntpoint,type,rw,total,total_free);
      }
   }
   printf("\n");
}

/*Here we  get who is at the moment connected to this computer*/
void get_user()
{
    char name[64];
   struct passwd *pwd;
   struct utmp *utmpx;
   struct hostent *hp;
   char *time ;
   
   while ((utmpx = getutent()) != NULL) {
      /*
       * Skip records that aren't logins.
       */
      if (utmpx->ut_type != USER_PROCESS)
	continue;
      
       if ((pwd = getpwnam(utmpx->ut_user)) != NULL)
            strcpy(name, pwd->pw_gecos);
        else
            sprintf(name, "#%d", pwd->pw_uid);
/*      printf("%-8s %-16.16s %-8.8s %.12s", utmpx->ut_user, name,
	     utmpx->ut_line, ctime(&utmpx->ut_time)+4);
         putchar('\n');*/
         time =  ctime(&utmpx->ut_time);
         time [strlen(time) -1 ] = '\0';
      printf("|user|%s|%s|%s|%s|%s", utmpx->ut_user, name,
	     utmpx->ut_line, utmpx->ut_host,time);
      /*if (utmpx->ut_ > 0)
	printf(" %s", utmpx->ut_host);
      putchar('\n');*/
       }
   putchar('\n');
}

/* Here we get collect process info.*/
void get_process()
{
 struct dirent * dentry;
      struct process_tmp ptmp;
      FILE * statfile;
      DIR * procdir;
      int pid,  counter ;
      struct stat statbuf;
      struct passwd *pwd;
      char statname[ FILENAME_MAX];

      if (!(procdir = opendir( "/proc/")))
      {
	 printf("There was error opening /proc");
	 return;
      }
      while ((dentry = readdir( procdir)))
      {
	 if (!(pid = atoi( dentry->d_name)))
	    continue;
/*printf (" Pid : %d  ",pid);*/

	 sprintf( statname, "/proc/%d/stat", pid);
	 if (!(statfile = fopen( statname, "r")))
	 {
	    printf("There was error opening opening stat process .");
	    continue;
	 }
	 if (fscanf( statfile, "%*d (%[^)]) %c %*d %*d %*d %*d %*d %*u %*u %*u"
	    "%*u %*u %lu %lu %*d %*d %*d %ld %*d %*d %*u %lu %ld %*u %*u %*u %*u"
	    "%*u %*u %*u %*u %*u %*u %lu %*u %*u",
	    ptmp.comm, &ptmp.state, &ptmp.utime, &ptmp.stime, &ptmp.priority, &ptmp.vsize,
	    &ptmp.rss, &ptmp.wchan) != 8)
	 {
	    printf("Special process wih pid:  %d.", pid);
	    fclose (statfile);
	    continue;
	 }
	 fclose( statfile);
/* printf (" %c \n", ptmp.state);*/

	 for (counter = 0; counter < number_monitored ; counter++)
	 {
	    if ( !strcmp(ptable[counter].name, ptmp.comm))
	    {
	       ptable[counter].working = 1;

/*  printf (" Pid : %d  ",pid);
		  printf (" %s %c %d %d %d %d %d %d \n",ptmp.comm, ptmp.state, ptmp.utime, ptmp.stime,ptmp.priority,ptmp.vsize,
		  ptmp.rss, ptmp.wchan);*/
	       printf("|process|%d|%s|%c|%d|",pid,ptmp.comm, ptmp.state, (ptmp.vsize/1024) );

	    }
	 }
      }
      for (ii = 0; ii < number_monitored; ii++)
      {
	 if ( !ptable[ii].working)
	    printf ("|process|%s|false", ptable[ii].name);

      }
      printf("\n");
}
/*We fill table where we hold processes names, which we want to monitor*/
void fill_table ()
{
   FILE *filet;
      int result, counter ;
      char scan[30];

      if (!(filet = fopen( CONF_FILE, "r")))
      {
	// printf("There was error opening opening configuration file .\n");
	
      }
   else
     {
      while ( result != EOF )
      {
	 result = fscanf(filet,"%s \n",scan);
	 if (result != 1 )
	 {
/*  printf("Only one processname should be in one line");*/

	 }
	 else
	 {
	    ptable[number_monitored].working = 0;
	    strcpy( ptable[number_monitored++].name ,scan);

	 }
      }
     }

}

void get_net1(int t)
{
   long rec_packet;                /* INP_PKT */
   long xmt_packet;                /* OUT_PKT */
   long coll_packet;    
   static char path[80];
   static FILE *fp_packet;
   char line[255];
   char ime[15]="";
   int i;
   char *dev = "  eth0";
   
   sprintf( path, "/proc/net/dev" );
   if( (fp_packet = fopen( path, "r" )) < 0 ) {
	   fprintf( stderr, "ERROR: cannot open %s\n", path );
	   exit( (-1) );
        }
   
   while( fgets( line, 255, fp_packet ) != NULL ) {
      if( line[6] == ':' && strlen( line ) > 55 ) {
	 /*printf("%s", line);*/
	 for ( i = 0; i < 6; i++)
	   {
	      ime [ i] = line[i];
	   }
	 ime [6] = '\0';
	 sscanf( &line[7],
		" %ld %*ld %*ld %*ld %*ld %ld %*ld %*ld %*ld %ld %*ld",
		&rec_packet, &xmt_packet, &coll_packet );
	/* printf("Ime : %s", ime); 
	 printf("\nReceived %d\n", rec_packet);
	 printf("Transimited %d\n", xmt_packet);
	 printf("Collisions %d\n", coll_packet);*/
	 if ( !strcmp(dev, ime))
	   {
	      if (t)
		{
		   in_pkt = rec_packet - in_pkt;
		   out_pkt = xmt_packet - out_pkt;
		   col_pkt = coll_packet - col_pkt;
		   /*printf(" prvic");*/
		}
	      else
		{
		   in_pkt = rec_packet ;
		   out_pkt = xmt_packet ;
		   col_pkt = coll_packet ;
		/*   printf("drugic");*/
		}
	   }
      }
      
   }
}
 
	 
	  
 main(argc, argv)
 int  argc;
char *argv[];

{
   get_net1(0);
   
   get_cpu(0);
   sleep(1);
   get_cpu(1);
   get_net1(1);
   get_load();
   printf("|GRAPH|IN_PKT|%d", in_pkt);
   printf("|GRAPH|OUT_PKT|%d", out_pkt);
   printf("|GRAPH|COLLISIONS|%d|\n", col_pkt);   
   get_mem();
   disk_usage();
   get_user();
   fill_table();
   get_process();
   exit(0);
}
