/* Compile it with this options :
gcc -o mtoold mtoold.c -lkvm -lkstat  -lelf
*/

//#include "os.h"
#include <signal.h>
#include <setjmp.h>
#include <ctype.h>
#include <sys/time.h>
#include <stdio.h>
#include <string.h>
/* includes specific to top */
#include "display.h"            /* interface to display package */
//#include "screen.h"           /* interface to screen package */
//#include "top.h"
//#include "top.local.h"
#include "boolean.h"
//#include "machine.h"
#include "utils.c"
#include "m_sunos5.c"
//#include "display.c"
#include "username.c"
#include <kvm.h>
float value = 0;
int i = 0;
 caddr_t processes;
 struct process_select ps;
extern int proc_compare();

char *GRAPH="GRAPH|";
char *VALUE="VALUE|";
char *SEPARATOR="|";

char *memory_names[] =
{"K real, ", "K active, ", "K free, ", "K swap, ", "K free swap", NULL};
char memory_buffer[MAX_COLS];

double *ave;
char *username();
char *itoa7();
static int lastline = 0;
static int display_width = MAX_COLS;
char *conf ="/etc/mtoold.conf";
char monitored_processes [15][15];
int number_monitored_processes=0;
int active_root_processes =0;

static void summary_format(str, numbers, names)

char *str;
int *numbers;
register char **names;

{
    register char *p;
    register int num;
    register char *thisname;
    register int useM = No;

    /* format each number followed by its string */
    p = str;
    while ((thisname = *names++) != NULL)
    {
        /* get the number to format */
        num = *numbers++;

        printf("\n%d\n",num);

        /* display only non-zero numbers */
        if (num > 0)
        {
            /* is this number in kilobytes? */
            if (thisname[0] == 'K')
            {
                /* yes: format it as a memory value */
                p = strecpy(p, format_k(num));

                /* skip over the K, since it was included by format_k */
                p = strecpy(p, thisname+1);
            }
            else
            {
                p = strecpy(p, itoa(num));
                p = strecpy(p, thisname);
            }
        }

        /* ignore negative numbers, but display corresponding string */
        else if (num < 0)
        {
            p = strecpy(p, thisname);
        }
        fflush(stdout);
    }

    /* if the last two characters in the string are ", ", delete them */
    p -= 2;
    if (p >= str && p[0] == ',' && p[1] == ' ')
    {
        *p = '\0';
    }
}


void quit(status)               /* exit under duress */

int status;

{
 
    exit(status);
    /*NOTREACHED*/
}



i_loadave(mpid, avenrun)

int mpid;
double *avenrun;

{
    register int i;

    /* i_loadave also clears the screen, since it is first */
  //  clear();

    /* mpid == -1 implies this system doesn't have an _mpid */
    if (mpid != -1)
    {
        printf("last pid: %5d;  ", mpid);
    }

    printf("load averages");

    for (i = 0; i < 3; i++)
    {
        printf("%c %5.2f",
            i == 0 ? ':' : ',',
            avenrun[i]);
    }
    printf("\n");
//    lmpid = mpid;
}


i_procstates(total, brkdn)

int total;
int *brkdn;

{
    register int i;
    static char **procstate_names;
    static char procstates_buffer[128];



    /* write current number of processes and remember the value */
    printf("%d processes:", total);


    /* put out enough spaces to get to column 15 */
    i = digits(total);
    while (i++ < 4)
    {
        putchar(' ');
    }

    /* format and print the process state summary */
//    summary_format(procstates_buffer, brkdn, procstate_names);
//    printf(" DATA|  %s", brkdn);

    /* save the numbers for next time */
//    memcpy(lprocstates, brkdn, num_procstates * sizeof(int));
}



get_mem (numbers)


int *numbers;

{
    register char *p;
    register int num;

    /* format each number followed by its string */
    for ( i = 0 ; i < 5 ; i++)
    {
        /* get the number to format */
      num = *numbers++;
      
      if ( i !=1 )     /*I dont get information about active memory*/
        {
          
          switch(i)
            
            {
            case 0:
              {  
                p  =  format_k(num);
                printf("%s|MEM_real|",VALUE);       /*write out MEM_real*/ 
                printf("%s|",p);
                break;
              }
            case 2:
              {
                p  =  format_k(num);
                printf("%s|MEM_free|",VALUE);       /*write out MEM_free*/ 
                printf("%s|",p);
                break;
              }
            case 3:
              {
                p  =  format_k(num);
                printf("%s|MEM_swap|",VALUE);       /*write out MEM_swap*/ 
                printf("%s|",p);
                break;
              } 
            case 4:
              {
                p  =  format_k(num);
                printf("%s|MEM_swap_free|",VALUE);   /*write out MEM_swap_free*/ 
                printf("%s|",p);
                break;
              } 
            }  
        }
    }
}




send_all ( sysinfo)
 struct system_info sysinfo;
{


  printf("%s|CPU_idle|",GRAPH);       //write out CPU_idle in %
  value = *sysinfo.cpustates++;
  printf("%4.2f|", ((float)value)/10.0);

  printf("%s|CPU_user||",GRAPH);       //write out CPU_user in %
  value = *sysinfo.cpustates++;
  printf("%4.2f|", ((float)value)/10.0);

  printf("%s|CPU_kernel||",GRAPH);       //write out CPU_kernel in %
  value = *sysinfo.cpustates++;
  printf("%4.2f|", ((float)value)/10.0);

  printf("%s|CPU_iowait||",GRAPH);       //write out CPU_iowait in %
  value = *sysinfo.cpustates++;
  printf("%4.2f|", ((float)value)/10.0);

  printf("%s|CPU_swap|",GRAPH);       //write out CPU_swap in %
  value = *sysinfo.cpustates++;
  printf("%4.2f||", ((float)value)/10.0);
  printf("%s|LOAD_avg1|",GRAPH);       /*write out Load AVG1*/
  printf("%4.2f||", sysinfo.load_avg[0]);
  printf("%s|LOAD_avg2|",GRAPH);       /*write out Load AVG2*/
  printf("%4.2f||", sysinfo.load_avg[1]);
  printf("%s|LOAD_avg3|",GRAPH);       /*write out Load AVG3*/
  printf("%4.2f||", sysinfo.load_avg[2]);
  printf("\n"); 
  get_mem(sysinfo.memory);

  /*take care for load average*/
  
 

  /*print out number of active all processes*/
 printf("%s|NUM_PROC|%d|\n",VALUE,active_root_processes);
  
}




i_process(line, thisline)

int line;
char *thisline;

{
    register char *p;
    register char *base;
    char newline[256] = "process:";
    char size[10];
    char time[10];
    char cpu[10];
    int size_i,time_i,cpu_i=0;
    int ii,iii;
    char word[15];
    int counter = 0;
   

    /* truncate the line to conform to our current screen width */
    thisline[display_width] = '\0';

    /* write the line out */

    counter =0;
    size_i = 0;
    for ( ii = 0; ii < strlen(thisline) ; ii++)
      {
        word[counter] = thisline[ii+63];
        counter++;
      }
    word[counter]='\0';
    
    for (ii = 0; ii < number_monitored_processes; ii++)
      {
        if ( !strcmp(monitored_processes[ii],word ) )
          {
            printf("|process|%s|",word); 
            for ( iii = 0; iii < strlen(thisline) ; iii++)
               {
                 if( (iii>23) && (iii<29) ) printf("%c",thisline[iii]);
                 if ( iii==29) printf("|");
                 if( (iii>42) && (iii<48) ) printf("%c",thisline[iii]);
                 if ( iii==48) printf("|");
                 if( (iii>54) && (iii<62) ) printf("%c",thisline[iii]);
                 if ( iii==62) printf("|");
               }

             //fputs(thisline, stdout);
             //printf("\n");
           }    
      }
}







main(argc, argv)

int  argc;
char *argv[];

{
  char *(*get_userid)() = username;
  struct statics statics;
  struct system_info system_info;
  struct process_select ps;
  int ii = 0;
  int active_procs;
  FILE *file;
  char temp[15];

        
  if (machine_init(&statics) == -1)
    {
      printf("\n\nDon't have enough priviliges, so quiting\n\n");
      exit(1);
    }

  /* Read data from configuration file*/
  

  file = fopen(conf, "r");
  
  if (file != NULL)
    {
      
      while ( (fgets(temp,256,file) != NULL))
        {
          if (strlen(temp) > 2)
            {
//            printf("\n got |%s",temp);
              strncat(monitored_processes[ii],temp,strlen(temp)-1);
//            printf("ujema se");
              ii++;
            }
        }
      number_monitored_processes = ii;
    }
  else
    {
      printf("\n\nConfiguration file not found !\n\n");
      exit(1);
    }
  
     fclose(file );
    
     /*
 printf("Stgefvilo procesov |%d\n",number_monitored_processes);
     printf("Izpisujem vse procese"); 
     for ( ii = 0; ii < number_monitored_processes; ii++)
       printf("%s\n",monitored_processes[ii]);
       */
 
  ps.idle    = Yes;
  ps.system  = No;
  ps.uid     = -1;
  ps.command = NULL;
  processes =  get_process_info(&system_info, &ps,  0);
  get_system_info(&system_info);
  active_root_processes =system_info.p_active;  
  ps.uid     = 0;
   
 // get_system_info(&system_info);
  processes =  get_process_info(&system_info, &ps,  0);
  
  usleep(750000);
  processes =  get_process_info(&system_info, &ps,  0);
  get_system_info(&system_info);
  send_all(&system_info);
   
   
  active_procs = system_info.p_active;
 
  get_userid = itoa7;   
  for (i = 0; i < active_procs; i++)
            {
                //fputs(format_next_process(processes, get_userid),stdout);
            i_process(i, format_next_process(processes, get_userid));
            }
 exit(0);   



}

