import java.io.*;
import java.net.*;

// This class is the thread that handles all communication with a client
// It also notifies the Vulture when the connection is dropped.
class Connection extends Thread {
  static int connection_number = 0;
  protected Socket client;
  protected Vulture vulture;
  protected DataInputStream in;
  protected PrintStream out;
  public static FileHandler file;
  public static DataInputStream inFile = null;
  public static PrintStream outFile = null;
  public static String string;
  protected Server server;
  protected InetAddress inet_address;
  protected boolean allowed = false;


    // Initialize the streams and start the thread
    public Connection(Socket client_socket, ThreadGroup threadgroup,
              int priority, Vulture vulture, Server s) 
    {
        // Give the thread a group, a name, and a priority.
        super(threadgroup, "Connection-" + connection_number++);
        this.setPriority(priority);
	
	

        // Save our other arguments away
        client = client_socket;
        this.vulture = vulture;
	server =s ;
        // Create the streams
        try { 
            in = new DataInputStream(client.getInputStream());
            out = new PrintStream(client.getOutputStream());
        }
        catch (IOException e) {
            try { client.close(); } catch (IOException e2) { ; }
            System.err.println("Exception while getting socket streams: " + e);
            return;
        }

	inet_address = client.getInetAddress();
	string = inet_address.toString();
	System.out.println("privezal z : " + string);
	for ( int aa =0; aa< server.access_number ; aa++)
	  {
	    if(!allowed)
	      {
		if ( (string.indexOf(server.access_names[aa]) >= 0) &&
		     (string.indexOf(server.access_names[aa]) <2 ))
		  {
		    allowed = true;
		     System.out.println("Access for "+string+" ALLOWED");
		  }
		else
		  {
		    allowed = false;
		     System.out.println("Access for "+string+" DENIED");
		  }
	      }
	  }

        // And start the thread up
        this.start();
    }
  
    // Provide the service.
    // Read a line, reverse it, send it back.  
    public void run() {
        String line;
	String line2,line3;
        StringBuffer revline;
        int len;
	CompData comp ;
	CompHist hist;
        // Send a welcome message to the client
        out.println("Mtool Data Server");
        out.println("Waiting for a command");
	try 
	  {
	    if (!allowed)
	      {
		try { client.close(); } catch (IOException e2) { ; }
	      }
	    else
	      {
		for(;;) 
		  {
		    try 
		      {
			// read in a line
			line = in.readLine();
			 if( line == null) break;
			// System.out.println("Dobil : " + line);
			 if (line.equalsIgnoreCase("COMP"))
			  {
			    //out.println("in COMP");
			    line = in.readLine();
			  //   System.out.println("Dobil : " + line);
			    for ( int i = 0; i < server.comp_vector.size(); i++)
			      {
				comp = (CompData) server.comp_vector.elementAt(i);
				//comp.write_all();
				if (line.equalsIgnoreCase(comp.get_name()))
				  {
				    if( comp.isActive())
				      {
					for (int mm = 0; mm <comp.get_lines_num()+ 1; mm++)
					  out.println(comp.get_line(mm));
					 out.println("|END|");
				      }
				    else
				      {
					 out.println("false");
					 out.println("|END|");
				      }
				  }		      
			      }
			  }
			else
			  if( line.equalsIgnoreCase("bye"))
			    {
			      line = null;
			      break;
			    }		
			  else
			    if (line.equalsIgnoreCase("GET_ALL"))
			      {
				for ( int i = 0; i < server.comp_vector.size(); i++)
				  {
				    comp = (CompData) server.comp_vector.elementAt(i);
				    out.println(comp.get_name());
				    out.println(comp.get_OS_type());
				    out.println(comp.get_nick());
				     
				  }
				out.println("END_ALL");
			      }
			    else
			      if (line.equalsIgnoreCase("COMP_HIST"))
				{
				   line = in.readLine();
				   for ( int o = 0; o < server.hist_vector.size(); o++)
				     {	
					hist =  (CompHist) server.hist_vector.elementAt(o);
					if (line.equalsIgnoreCase(hist.get_name()))
					  {
					     for (int mm = 0; mm <hist.get_lines_num()+ 1; mm++)
					       out.println(hist.get_line(mm));
					  }
				     }
				   out.println("|END|");
				}
			 else
			    if (line.equalsIgnoreCase("COMP_REMOVE"))
			      {
				line = in.readLine();
				line2 = in.readLine();
				line3 = in.readLine();
				(new ConfigFile()).remove(line,line2,line3);
			      }
			    else
			      if (line.equalsIgnoreCase("COMP_ADD"))
				{
				  line = in.readLine();
				  line2 = in.readLine();
				  line3 = in.readLine();
				  (new ConfigFile()).add(line,line2,line3);
				}

		      }catch (NullPointerException e) { ; }
		  }
	      }
	  }
        catch (IOException e) { ; }
	
	
	// When we're done, for whatever reason, be sure to close
        // the socket, and to notify the Vulture object.  Note that
        // we have to use synchronized first to lock the vulture
        // object before we can call notify() for it.
        finally {
	  try { client.close(); } catch (IOException e2) { ; }
	  synchronized (vulture) { vulture.notify(); }
	}
   }
  
 
  // This method returns the string representation of the Connection.
  // This is the string that will appear in the GUI List.
    public String toString() {
      return this.getName() + " connected to: " 
+ client.getInetAddress().getHostName()
  + ":" + client.getPort();
    }

	 protected void finalize()
	 {
	    System.out.println("Pocistil! ");
	    try { client.close(); } catch (IOException e2) { ; } 
	    
	 }
	 
	 }

