/** Changes:
7.5.98 added OS type. OS type should be written in configuration file, after computer name, separated with space
example:
storm.uni-mb.si linux

12.5.98 ADDED remove and add hosts from aplication. Files used for this is ConfigFile.java. USE: (new ConfigFile()).add("name_of computer")


8.6.1998 Added computer nick in config file

*/



import java.net.*;
import java.io.*;
import java.awt.*;
import java.util.*;

public class Server extends Thread {
    public final static int DEFAULT_PORT = 41233;
    protected int port;
    protected ServerSocket listen_socket;
    protected ThreadGroup threadgroup;
    protected List connection_list;
    protected Vector connections;
    protected Vulture vulture;
  final static String conf_file = "config";
  public static FileHandler file;
  public static DataInputStream inFile = null;
  public static PrintStream outFile = null;
  public static String comp_names [] = new String [30];
  public static String comp_type [] = new String [30];
  public static String access_names [] = new String [30];
  public static String comp_nick [] = new String [30];
  public static int access_number = 0;
  public static int comp_number = 0;
  public static int refresh = 5;
  public static CompData COMP;
  protected GetDataThread get_data_thread;
  public static Vector comp_vector = new Vector();
  protected CollectThread collect_thread;

  CompHist HIST  ;
  public static Vector hist_vector = new Vector();


    // Exit with an error message, when an exception occurs.
    public static void fail(Exception e, String msg) {
        System.err.println(msg + ": " +  e);
        System.exit(1);
    }
    
    // Create a ServerSocket to listen for connections on;  start the thread.
    public Server(int port) {
        // Create our server thread with a name.
        super("Server");
        if (port == 0) port = DEFAULT_PORT;
        this.port = port;
        try { listen_socket = new ServerSocket(port); }
        catch (IOException e) { fail(e, "Exception creating server socket"); }
        // Create a threadgroup for our connections
        threadgroup = new ThreadGroup("Server Connections");
	/*
         Create a window to display our connections in
        Frame f = new Frame("Server Status");
        connection_list = new List();
        f.add("Center", connection_list);
        f.resize(400, 200);
        f.show();
	*/
        // Initialize a vector to store our connections in

	if (!read_configuration ())
	  {
	    System.out.println("\nCouldn't read configuration file! \n Closing program ! \n");
	  }
	/*
	for ( int i =0; i< comp_number; i++)
	  System.out.println("names : "+comp_names[i]);
	System.out.println("refresh :" + refresh);
	*/

	
	for ( int i = 0; i < comp_number; i++)
	  {
	    COMP = new CompData(comp_names[i], comp_type[i],comp_nick[i]) ; //changed when added OS type
	    COMP.setActive(false);
	    COMP.reset();
	    COMP.set_name(comp_names[i]);
	    COMP.set_nick(comp_nick[i]);
	    HIST = new CompHist(comp_names[i]);
	    hist_vector.addElement(HIST);
	    System.out.println("Computer name : "+comp_names[i]);
	    System.out.println("Computer type : "+comp_type[i]);
	    System.out.println("Computer nick  : "+comp_nick[i]);
	    comp_vector.addElement(COMP);
	   
	  }
	/*
  	for ( int ii = 0; ii < comp_vector.size(); ii++)
	  {
	    System.out.println("iii"+ii);
	    COMP = (CompData) comp_vector.elementAt(ii);
	    System.out.println("NAMEW : " +COMP.get_name());
	    System.out.println("NICK : " +COMP.get_nick());
	  }
	*/
	  

	
	for ( int i = 0; i < access_number; i++)
	  {
	    System.out.println("access : "+access_names[i]);
	  }


        connections = new Vector();

        // Create a Vulture thread to wait for other threads to die.
        // It starts itself automatically.
        vulture = new Vulture(this);
	get_data_thread = new GetDataThread( this);
	//	collect_thread = new CollectThread(this);
        

// Start the server listening for connections
        this.start();
    }
    


  public boolean read_configuration ()
  {
    String string;
    boolean success = false;
    
    file = new FileHandler(conf_file,"READ");
    if ( file != null)
      {
	inFile = file.inputStream();
	outFile = file.outputStream();
	try
	  {
	    while ( (string = inFile.readLine()) != null )
	      {
		if ((string.length() > 0) && (string != null)) 
		  {
		    if ( !(string.charAt(0) == '#') )
		      {
			if (string.equalsIgnoreCase("time"))
			  {
			    string = inFile.readLine();
			    refresh = (int) new Integer(string).intValue();
			  }
			
			else
			  if (string.equalsIgnoreCase("access"))
			    {
			      while ( (string = inFile.readLine()) != null )
				{
				  if ((string.length() > 3) && (string != null)) 
				    {

				      access_names[access_number] = string;
				      access_number ++;
				    }
				}
			      break;
			    }
			  else
			    {
			      if (string.length() > 4)
				{
				  //System.out.println(string);
				  StringTokenizer st = new StringTokenizer(string, " ");
				  
				  comp_names[comp_number] = st.nextToken();
				  comp_type[comp_number] = st.nextToken();
				  comp_nick[comp_number] = st.nextToken();
				   System.out.println("Dodal tip :"+ comp_type[comp_number]);
				  comp_number ++ ;
				  
				}
			    }
		      }
		  }
		success = true;
	      }
	    
	  }
	catch (IOException e ) {}
	file.close("READ");			
      }
    return success;
  }







    // The body of the server thread.  Loop forever, listening for and
    // accepting connections from clients.  For each connection, 
    // create a Connection object to handle communication through the
    // new Socket.  When we create a new connection, add it to the
    // Vector of connections, and display it in the List.  Note that we
    // use synchronized to lock the Vector of connections.  
   
    public void run() {
        try {
            while(true) 
	     {
                Socket client_socket = listen_socket.accept();
                Connection c = new Connection(client_socket, threadgroup,
					      3, vulture, this);
                // prevent simultaneous access.
                synchronized (connections) 
		  {
		     connections.addElement(c);
		     //connection_list.addItem(c.toString());
		  }
		System.runFinalization();
	     }
        }
        catch (IOException e) {
            fail(e, "Exception while listening for connections");
        }
    }
    
    // Start the server up, listening on an optionally specified port
    public static void main(String[] args) {
        int port = 0;
        if (args.length == 1) {
            try { port = Integer.parseInt(args[0]); }
            catch (NumberFormatException e) { port = 0; }
        }
        new Server(port);
    }
}

